#include <LocoNet.h>

lnMsg *LnPacket;
LnBuf LnTxBuffer;

void setup() {
  // Inicializamos la interfaz Loconet en el pin 7 de arduino
  LocoNet.init(7);

  // Configuramos el puerto serie a 19200 baudios
  Serial.begin(19200);
}

void loop() {

  // Comprobamos los paquetes entrantes por el bus Loconet
  LnPacket = LocoNet.receive();  
  
  if(LnPacket) {
    uint8_t msgLen = getLnMsgSize(LnPacket); //Calculamos la longitud del paquete recibido
    for (uint8_t x = 0; x < msgLen; x++)
      Serial.write(LnPacket->data[x]); //Enviamos por el puerto serie los bites recibidos
  }


  // Comprobamos los paquete entrantes por el pierto serie
  if(Serial.available()) { 
    
    uint8_t inByte = Serial.read() & 0xFF;
    addByteLnBuf(&LnTxBuffer, inByte);
    
    LnPacket = recvLnMsg( &LnTxBuffer );
    if(LnPacket) LocoNet.send(LnPacket);
  }
}
